<?php

namespace NoccyLabs\Mercureact\Broker;

use NoccyLabs\SimpleJWT\JWTToken;
use Psr\Http\Message\ServerRequestInterface;
use React\Stream\WritableStreamInterface;
use Symfony\Component\Uid\Uuid;

class SseSubscriber implements SubscriberInterface
{
    private string $id;

    public function __construct(
        private WritableStreamInterface $stream,
        private ServerRequestInterface $request,
    )
    {
        $this->id = (string)Uuid::v7();
    }

    public function deliver(Message $message): void
    {
        $this->stream->write($message->toString());
    }

    public function isAuthorized(): bool
    {
        return $this->request->getAttribute('authorization') instanceof JWTToken;
    }

    public function getId(): string
    {
        return "urn:uuid:".$this->id;
    }
}